Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/object_template_impl.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/object_template_impl.hpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/object_template_impl.hpp	(revision 1875)
@@ -216,5 +216,5 @@
 
    template<typename T>
-   void CObjectTemplate<T>::sendAllAttributesToServer(CContextClient* client)
+   void CObjectTemplate<T>::sendAllAttributesToServer(CContextClient* client, const string& objectId)
    {
      CAttributeMap& attrMap = *this;
@@ -222,10 +222,10 @@
      for (; it != itE; ++it)
      {
-       if (it->second->doSend() && !(it->second)->isEmpty()) sendAttributToServer(*(it->second), client);
+       if (it->second->doSend() && !(it->second)->isEmpty()) sendAttributToServer(*(it->second), client, objectId);
      }
    }
 
    template <class T>
-   void CObjectTemplate<T>::sendAttributToServer(const string& id, CContextClient* client)
+   void CObjectTemplate<T>::sendAttributToServer(const string& id, CContextClient* client, const string& objectId )
    {
       CAttributeMap & attrMap = *this;
@@ -235,5 +235,5 @@
 
   template <class T>
-  void CObjectTemplate<T>::sendAttributToServer(CAttribute& attr, CContextClient* client)
+  void CObjectTemplate<T>::sendAttributToServer(CAttribute& attr, CContextClient* client, const string& objectId)
   {
     CEventClient event(getType(),EVENT_ID_SEND_ATTRIBUTE);
@@ -241,5 +241,6 @@
     {
       CMessage msg;
-      msg<<this->getId(); 
+      if (objectId.empty()) msg << this->getId();
+      else msg << objectId;
       msg << attr.getName();
       msg << attr;
@@ -254,5 +255,5 @@
 /* specialisation for context, because context Id on client is not the same on server, and no need to transfer context Id */
   template <>
-  void CObjectTemplate<CContext>::sendAttributToServer(CAttribute& attr, CContextClient* client)
+  void CObjectTemplate<CContext>::sendAttributToServer(CAttribute& attr, CContextClient* client, const string& objectId)
   {
     CEventClient event(getType(),EVENT_ID_SEND_ATTRIBUTE);
@@ -278,5 +279,5 @@
 
   template<class T>
-  void CObjectTemplate<T>::sendAddItem(const StdString& id, int itemType, CContextClient* client)
+  void CObjectTemplate<T>::sendAddItem(const StdString& id, int itemType, CContextClient* client, const string& objectId)
   {
     typedef typename T::EEventId ItemType;
@@ -285,5 +286,6 @@
      {
        CMessage msg;
-       msg << this->getId();
+       if (objectId.empty()) msg << this->getId();
+       else msg << objectId;
        msg << id;
        const std::list<int>& ranks = client->getRanksServerLeader();
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/test/generic_testcase.f90
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/test/generic_testcase.f90	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/test/generic_testcase.f90	(revision 1875)
@@ -1860,8 +1860,8 @@
         bounds_lon(3,i,j)=bounds_lon_glo(1,ibegin+i)
         bounds_lon(4,i,j)=bounds_lon_glo(2,ibegin+i)
-        bounds_lat(1,i,j)=bounds_lat_glo(1,ibegin+i)
-        bounds_lat(2,i,j)=bounds_lat_glo(1,ibegin+i)
-        bounds_lat(3,i,j)=bounds_lat_glo(2,ibegin+i)
-        bounds_lat(4,i,j)=bounds_lat_glo(2,ibegin+i)
+        bounds_lat(1,i,j)=bounds_lat_glo(1,jbegin+j)
+        bounds_lat(2,i,j)=bounds_lat_glo(1,jbegin+j)
+        bounds_lat(3,i,j)=bounds_lat_glo(2,jbegin+j)
+        bounds_lat(4,i,j)=bounds_lat_glo(2,jbegin+j)
 
         ij=(j+offset_j)*(ni+2*offset_i)+i+offset_i
@@ -1908,4 +1908,5 @@
       CALL xios_set_domain_attr(TRIM(domain_id), nj_glo=nj_glo, jbegin=jbegin, nj=nj, data_jbegin=-offset_j, data_nj=nj+2*offset_j)
       CALL xios_set_domain_attr(TRIM(domain_id), data_dim=2, lonvalue_2d=lon, latvalue_2d=lat, mask_1d=return_mask)
+      CALL xios_set_domain_attr(TRIM(domain_id), bounds_lon_2d=bounds_lon, bounds_lat_2d=bounds_lat, nvertex=4)
     ENDIF
 
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/domain_algorithm_interpolate.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/domain_algorithm_interpolate.cpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/domain_algorithm_interpolate.cpp	(revision 1875)
@@ -171,4 +171,11 @@
       step=(domainSrc_->lat_end-domainSrc_->lat_start)/domainSrc_->nj_glo ;
       for (int i=0; i<domainSrc_->ni_glo; ++i) lat_g(i)=domainSrc_->lat_start+i*step ;
+    }
+    else if (!domainSrc_->lonvalue.isEmpty() && !domainSrc_->latvalue.isEmpty())  // data can come possibly from coupler so only lonvalue and latvalue are defined ?
+    {
+      CArray<double,1> lon(niSrc), lat(njSrc) ;
+      for(int i=0; i< niSrc;++i) lon(i) = domainSrc_->lonvalue(i) ;
+      for(int j=0, n=0; j<njSrc; ++j, n+=niSrc) lat(j) = domainSrc_->latvalue(n) ;
+      domainSrc_->AllgatherRectilinearLonLat(lon, lat, lon_g, lat_g) ;
     }
     else ERROR("void CDomainAlgorithmInterpolate::computeRemap()",<<"Cannot compute bounds for rectilinear domain") ;
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/type/type_decl.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/type/type_decl.cpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/type/type_decl.cpp	(revision 1875)
@@ -33,8 +33,14 @@
   
   macro(string)
+  macro(char)
+  macro(short)
   macro(int)
+  macro(unsigned int)
+  macro(long)
+  macro(unsigned long)
+  macro(long long)
+  macro(unsigned long long)
   macro(double)
   macro(bool)
-  macro(StdSize)
   macro(CDate)
   macro(CDuration)
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/type/type_util.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/type/type_util.hpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/type/type_util.hpp	(revision 1875)
@@ -76,5 +76,7 @@
   macro(unsigned int)
   macro(long)
+  macro(long long)
   macro(unsigned long)
+  macro(unsigned long long)
   macro(float)
   macro(double)
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/xios_spl.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/xios_spl.hpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/xios_spl.hpp	(revision 1875)
@@ -49,7 +49,9 @@
 typedef std::size_t        StdSize;
 
-typedef  unsigned short int   ushort;
-typedef  unsigned int         uint;
-typedef  unsigned long int    ulong;
+typedef  unsigned short int      ushort;
+typedef  unsigned int            uint;
+typedef  unsigned long int       ulong;
+typedef  long long int           longlong;
+typedef  unsigned long long int  ulonglong;
 
 const size_t stringArrayLen=255 ;
